#ifndef ComposerView_First

#ifdef __GNUG__
#pragma once
#endif

#define ComposerView_First

// @(#)Composer.h	2.21	10/29/91


const int	cCOMPOSEDONE=	cUSERCMD + 0;


ostream & SaveETI(ostream &os, EditTextItem *eti);
istream & LoadETI(istream &is, EditTextItem *eti);

#include "TreeView.h"

class ComposerView: public TreeView {
    class QueryDialog	*qd;
    class Menu		*menu;
    class Menu		*oprmenu;
    class Menu		*attrmenu;
    class Menu		*tattrmenu;
    class Menu		*procmenu;
    class Menu		*predefmenu;
    int			oldoprtype;
    class QNode		*qtree;
    class QNode		*oldqtree;
    byte		*qtext;

    int			nfields;
    char		**attr;

    bool		IsValid(class QNode *);
    char		*GetWhere(char *, class QNode *);
    char		*table_name;
    char		*db_name;
    char		**attr_types;
    void		UndoLastChange();
protected:
    class DoneDialogView *dv;
    class TextView	*tv;

    void		SetTv();
public:
    MetaDef(ComposerView);

    ComposerView(class QueryDialog *qd, char *dbname, char *tname,
	int nf, char **a, char **atypes);
    ~ComposerView();

#ifdef ET23
    Command *DispatchEvents(Point lp, Token &t, Clipper *vf);
#else
    Command *DispatchEvents(Point lp, Token t, Clipper *vf);
#endif

    QNode *GetQTree() { return qtree; }
    void SetQTree(QNode *n);
    void SaveOldTree();

    Command *NodeSelected(VObject*, int cl);
    TreeNode *FindTreeNode(VObject *vop);

    void DoEdit(QNode *qn);
    void ChangeConst(QNode *qn);
    void ViewRect(QNode *qn);
    void ChangeAttr(QNode *qn, int aindex);
    bool IsValid();
    bool IsActive();

    void SetManEdit(bool);
    bool Manual();

    char *GetWhere();
    char *GetTableName()	{ return table_name; }
    char *GetDbName()		{ return db_name; }
    int GetNfields()		{ return nfields; }
    char ** GetAttr()		{ return attr; }
    char ** GetAttrTypes()	{ return attr_types; }

    void NewQTree();

    //---- construction
    VObject *NodeAsVObject(Object *);
    Iterator *MakeChildrenIter(Object *);

    //---- menu
    Menu *GetMenu();
    void DoCreateMenu(Menu *menu);
    void DoSetupMenu(Menu *menu);
    Command *DoMenuCommand(int cmd);

    istream &Load(istream &);
    ostream &Save(ostream &);
};

class Composer: public ComposerView {
    class Window	*w;
public:
    MetaDef(Composer);

    Composer(QueryDialog *, char *dbname, char *tname,
	int nf, char **a, char **atypes);
    ~Composer();
    bool PrintOnWhenObserved(Object*) { return FALSE; }

    void Show();
    char *GetWhere();
};

#endif ComposerView_First
