// @(#)QueryDialog.h	2.21	10/29/91

#ifndef QueryDialog_First

#ifdef __GNUG__
#pragma once
#endif

#define QueryDialog_First

#include	"Object.h"
#include	"Dialog.h"
#include	"DialogItems.h"

class QueryDialog: public Dialog {
    friend class GQuery;
    class GQuery	*q;
    RestrTextItem	*query_name;
    bool		query_name_changed;
    char		*table_name_s, *database_name_s;
    class PopupItem	*datab_pu, *table_pu, *icon_pu, *color_pu, *width_pu;
    int			cur_color_no, cur_width_no;
    Menu		*table_menu;
    Menu		*icon_menu;
    Menu		*color_menu;
    Menu		*width_menu;
    Menu		*database_menu;
    class ToggleButton	*show_on_map;
    class ToggleButton	*epoch;
    class ToggleButton	*dont_refresh;
    class ToggleButton	*dont_pick;
    class ToggleButton	*attr_label;
    class RadioButton	*preview_but;
    bool		cancelled;
    class TableDialog	*t;
    class Composer	*cv;
    int			cur_icon_no;
    bool		changed_doc;
    class ToggleButton	**show_field;
    class TextItem	**show_label;
    char		**show_attr;
    char		**attr_types;
    int			nfields;
    int			n_showfields;
    byte		*title;
    char		*where_s;
    class DynInfo	*dinfo;
    Object		*obs;
    bool		has_dyn, has_loc, has_pline, has_color,
			has_icon, has_width;
    Set			*loose_ed;
    Set			*active_ed;
    Point		old_icon_size;
protected:
    void DoPreview(Collection *cp);
    void DoSetup();
    void FillTableMenu();
public:
    MetaDef(QueryDialog);

    QueryDialog(byte *title, GQuery *);
    ~QueryDialog();

    void SetObs() { if (!obs) { obs= (Object*) q; AddObserver((Object*) q); } }
    bool PrintOnWhenObserved(Object*) { return FALSE; }
    // VObject has a faulty IsEqual defition:
    bool IsEqual(Object *anOp) { return anOp == this; }

    void LooseFree();
    void LooseAdd(Object *o);
    void ActiveAdd(Object *o);
    void RefreshQuery();
    void UpdatePreview(bool update= FALSE);
    void ShowIt();
    void UpdateWhere(bool update_pv= TRUE);

    class VObject *DoCreateDialog();
    void Control(int id, int p, void *v);
    void DoObserve(int id, int part, void *data, Object *o);
    bool QueryNameChanged() const { return query_name_changed; }
    char *QueryName() const { return query_name->GetText()->AsString(); }
    char *TableName() const { return table_name_s; }
    char *DataBaseName() const { return database_name_s; }
    class TableDialog * GetTD() const { return t; }
    class GQuery * GetGQ() const { return q; }
    class MapView * GetDrawView();
    char **GetAttr(bool all= FALSE);
    int NrAttr()	const { return n_showfields; }
    int NrTuples();
    void FillFields();
    void CheckFields();
    void FetchQuery();
    class Bitmap *GetIconBitmap();
    bool ShowOnMap();
    bool Epoch();
    bool DontRefresh();
    bool DontPick();
    bool ShowAttrLabel();
    bool Cancelled() const { return cancelled; }
    bool ChangedDoc() const { return changed_doc; }
    int	GetColor();
    int	GetWidth();
    bool EditShape(long oid);
    char *GetWhere() const { return where_s; }
    bool Manual();
    bool HasLoc() const { return has_loc; }
    bool HasPline() const { return has_pline; }
    bool HasColor() const { return has_color; }
    bool HasIcon() const { return has_icon; }
    bool HasWidth() const { return has_width; }
    bool HasDyn() const { return has_dyn; }
    DynInfo *GetDyn() const { return has_dyn ? dinfo: 0; }

    ostream &Save(ostream &);
    istream &Load(istream &);
};

#endif QueryDialog_First
