static char *sccs_id= (sccs_id, "%W% %G%");

/*
 * This file implements a GeoShape which draws maps which
 * have a binary attribute.
 * These are created with the rtree/makebinpath script.
 */

#include "Class.h"
#include "OverView.h"
#include "IconShape.h"

#include "utils/geo-decls.h"


class BinPathShape: public PlineShape {
public:
  BinPathShape(MapView *, int n, char **str);

  Point *GetPts() { return pts; }
};


extern "C" BinPathShape *make_bin_path(MapView *dv, int n, char **str)
{
  BinPathShape *s= new BinPathShape(dv, n, str);
#if 0
  if (s->GetPts() == 0) {
    delete s;
    return 0
  }
#endif
  return s;
}



BinPathShape::BinPathShape(MapView *d, int n, char **str): (d, 0)
{
    PATH *path= (PATH*) str[0];
    closed= str[1][0] == 't';
    npoints= path->npts;

    register int	i;
    register int	np= 0;
    Point		lastp, newp;
    Point		tpts[50000];

    for (i= 0; i < npoints && np < 10000; i++) {
      float Long= path->p[i].x;
      float Lat= path->p[i].y;
      newp= dv->GeoToPoint(Long,Lat);
      if (newp == BADPOINT) {
	np= 1;
	break;
      }
      if (np == 0 || newp != lastp) {
        tpts[np]= lastp= newp;
	np++;
      }
    }

    Rectangle bbox;
    if (np == 1) {
      npoints= 0;
      pts= 0;
      bbox= Rectangle(tpts[0], gPoint0);
    } else {
      npoints= np;
      pts= new Point[npoints];
      bcopy(tpts, pts, npoints * sizeof(Point));
      bbox= NormRect(pts[0],pts[npoints-1]);
    }

    labelpos= bbox.Center();
    width= 1;
}
