//****************************************************************************
// File: geometr.h
//****************************************************************************

#ifndef __RECT
#define __RECT

#include "typedefs.h"

class geometr {
   static char gplusplus_no_warn;

   line_situation evaluate_spl_line(point pt1,point pt2,point c,coord r);
   line_situation evaluate_rect_line(point p1, point p2, point rect[2]);
   line_situation evaluate_pt_line(point pt1,point pt2,point pt);
public:
   geometr() { }

   void len_vector(point v, coord *length);
   void inprod(point pt1, point vect, coord *c);
   void diff_vect(point p1, point p2, point p3);
   void intersect(point rect[2], point n, coord c, double_point seg[2]);
   void intersect(point b, point e, point n, coord *c, point pt);
   boolean intersect(point n, coord *c, int nop, point *pol, side_type side,
                     int &new_nop, point* &new_pol, point seg[2]);

   boolean point_left_plane(point pt, point n_vector, coord *c);
   boolean point_right_plane(point pt, point n_vector, coord *c);
   boolean rect_left_plane(point rect[2], point n_vec, coord *lc);
   boolean rect_right_plane(point rect[2], point n_vec, coord *rc);
   boolean sphere_left_plane(point m_pt, coord *rad, point norm, coord *c);
   boolean sphere_right_plane(point m_pt, coord *rad, point norm, coord *c);
   boolean pol_left_plane(int nop, point *pts, point norm, coord *c);
   boolean pol_right_plane(int nop, point *pts, point norm, coord *c);
   boolean left_touched(point mid, coord *rad, point n_vec, coord *c);
   boolean right_touched(point mid, coord *rad, point n_vec, coord *c);
   boolean point_inside(point rect[2], point pt);
   boolean point_inside(point pt, point mid_pt, coord radius);
   boolean point_inside(point pt, int nop, point *pts);

   void to_rectangle(point *polygon, int nop, point rect[2]);
   void to_sphere(point *polygon, int nop, point c, coord &r);
   void pt_cpy(point pts, point ptd);
   void cpy_to_pol(point rectangle[2], point *pol);
   void rect_cpy(point rects[2], point rectd[2]);
   void calc_rect(point rects1[2], point rects2[2], point rectd[2]);
   coord calc_area(point rect[2]);
   coord distance(point p1, point p2);

   boolean cover(point rect1[2], point rect2[2]);
   boolean cover(point pt1, coord r1, point pt2, coord r2);
   boolean overlap(point rect1[2], point rect2[2]);   // 2 rectangles
   boolean overlap(point pt1, coord r1, point pt2, coord r2); // 2 spheres
   boolean overlap(point rect[2], point pt, coord r); // rectangle and sphere
   boolean overlap(int nop, point *pts, point pt, coord r); // convex and sphere
   boolean overlap(int nop, point *pts, point rect[2]); // convex and rectangle

   boolean point_equal(point pt1, point pt2);
   boolean sphere_equal(point m_pt1, coord rad1, point m_pt2, coord rad2);
   boolean rect_equal(point rect1[2], point rect2[2]);

   ~geometr() { }
};

#endif
