//*****************************************************************************
// File: node.cc
// Implementation of a node of the r - tree.
//*****************************************************************************

#include <stdio.h>
#include <std.h>
#include <sys/file.h>

#include "node.h"

void node::total_rectangle(point rect[2])
{
   coord min, max;

   for (int d = 0; d < DIM; d++) {
      min = entry[0].mbr[0][d];
      max = entry[0].mbr[1][d];
      for (int e = 1; e < nr_of_entries; e++) {
         if (entry[e].mbr[0][d] < min) min = entry[e].mbr[0][d];
         if (entry[e].mbr[1][d] > max) max = entry[e].mbr[1][d];
      }
      rect[0][d] = min;
      rect[1][d] = max;
   }
}


void node::copy_to_list(r_entry *list)
{
   for (int entry_no = 0; entry_no < nr_of_entries; entry_no++) {
      list[entry_no] = entry[entry_no];
   }
}

void node::clear()
{
   nr_of_entries=0;
}

void node::add_entry(r_entry new_entry)
// Change information 
{
   // Assume:number of entries is less than maximum_number_of_entries.

   entry[nr_of_entries++] = new_entry;
}


void node::del_entry(r_entry old_entry)
{
   // Assume: number of entries is greater than 0 and entry is present.
   int i;

   for (i=0; (i<nr_of_entries)&&(entry[i].id != old_entry.id);i++);
   if (i==nr_of_entries) {
      printf("Bad news: implementation error in class node (del_entry)\n");
      exit(1);
   }
   int j = --nr_of_entries;
   if (i < j) entry[i] = entry[j];
   entry[j].id = NULL_ID;
}

