//*****************************************************************************
// File: node.h
// Definition of a node of the "r-tree"
//*****************************************************************************

#ifndef __NODE
#define __NODE

#include "typedefs.h"

class node {
   friend class r_tree;
private:
   // This 'data'-part is usually in mapped memory.
   int		nr_of_entries;
   r_entry	entry[MAX];
   char		unused[UNUSED];
public:
   // Utility functions to ease the use of nodes (only used in rtree.cc)
   node() {};   // Never used, because the nodes are in mapped memory.
   void total_rectangle(point rect[2]);
   void copy_to_list(r_entry *list);
   void clear();
   void add_entry(r_entry new_entry); 
   void del_entry(r_entry old_entry);
   ~ node() {}; // Never used.
};

#endif
